// TLM_GPU header file Cuda TLM project

/*
    Copyright 2010 Computational Electromagnetics Research Laboratory (CERL)
    University of Victoria, Victoria, B.C. Canada
    http://www.cerl.ece.uvic.ca
    http://www.cerl.ece.uvic.ca/Open_Source_CEM.htm
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#define BLOCK_SIZE_X 64
#define BLOCK_SIZE_Y 1
#define BLOCK_SIZE_Z 1

#define PI 3.1415926535897


#define __DEBUG_CUDA_READ
#define __DEBUG_CUDA_SCATTER
#define __DEBUG_CUDA_IMPULSEINTERCHANGE
#define __DEBUG_CUDA_BOUNDARY
#define __DEBUG_CUDA_WRITE


# define VEL_LIGHT  299792458  // m/sec


struct __align__(16) Varm{
	//float v0;
	float v1;
	float v2;
	float v3;
	float v4;
	float v5;
	float v6;
	float v7;
	float v8;
	float v9;
	float v10;
	float v11;
	float v12;
	float Bndry_Dir; // Boundary Direction 0 = none, down-1,left=2,up=4,right=4
	//float Yo; // node Permitivity
	//float RefCoeff; // Reflection Coeficient of Boundary
	//float DEBUG; // omit when done debugging. 

};

struct iterationSetupType{
		int meshDim_X,meshDim_Y,meshDim_Z;
		int thread_BLK_X,thread_BLK_Y,thread_BLK_Z;
		int blocksPerXGrid; 
		int blocksPerYGrid; 
		int nodes_per_Zslice;
		int slices_Per_Zdim;
		dim3 threads; 
		dim3 grid;
	};


extern "C"
{
	void printCPU_results();
	void printCUDA_results();

	int cube_add_CPU(int z, int y, int x);
	int cube_add_GPU(int z, int y, int x);
}

